/* eslint-disabled */
/**
 * 测试工具
 */

!(function (o) {
    'use strict';

    // 是否为测试模式, 设置为1此文件才可用
    var IS_TEST_MODE = 0;
    o.autoTest = o.autoTest || {};
    if (!IS_TEST_MODE) {
        return false;
    }

    var elmentsetTimeInterval = '';
    var indexTimeInterval = '';

    var timeCheckConfig = 500;
    var timeLine = 0;
    var timeSpace = 1000;
    var timeCheckSpace = 1000;
    var COND_CONTINUE = 0;
    var COND_OK = 1;
    var COND_ERROR = 2;
    var lastJs = '';

    window.confighelp = 1;


    function loadConfig () {
        var path;
        if (location.protocol === 'file:') {

            // 本地页面;
            path = '../../libs/confighelp.conf';
        } else {

            // 服务端页面
            path = './libs/confighelp.conf';
        }

        $.get(path, function (js) {
            if (lastJs === js) {
                console.error('Same js, no run');
                return;
            }
            timeLine = 0;
            console.debug('Get new config,  data is: ' + js);
            eval(js);

            lastJs = js;
        });
    }


    //文本点击函数
    function textclick (ele, info, delay, laststr, clickflag) {
        delay = delay || 1000;
    	clickflag = clickflag || 0;
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            var selector = "";
            selector = ele + ":contains(" + info + ")";
            if (laststr !== 'undefined') {
                selector = selector + laststr;
            }
            if ($(selector)[0]) {
                if ($(selector)[0].offsetWidth > 0) {
                    writeLog('[TEXTCLICK]sure exist');
                    $(selector)[0].click();
                } else {
                    if (clickflag == 0) {
                        //writeLog('[TEXTCLICK]error show');
                    } else {
                        writeLog('[TEXTCLICK]sure exist');
                        $(selector)[0].click();
                    }

                }
            } else {
                //writeLog('[TEXTCLICK][ELE]error find2');
            }
        }, timeLine);
    }


    function click (selector, delay) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            //console.log('click: ', selector);
            if ($(selector)[0]) {
                $(selector)[0].click();
            } else {
                writeLog('[click][ELE] "' + selector + '" not find');
            }
        }, timeLine);
    }

    function getText (selector, delay) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            //console.log('getText: ', selector);
            var info = "";
            if ($(selector)[0]) {
                //info = Base64.encode($(selector)[0].innerText);
                info = $(selector)[0].innerText + '_'
                if (info == "") {
                    writeLog("[getText]fail");
                    //console.log("[getText]fail");
                } else {
                    info = info.replace(/\n/g, ";");
                    info = "[getText]success" + info;
                    //console.log(info);
                    writeLog(info);
                }
            } else {
                //writeLog('[getText][ELE] "'+selector+'" not find')
                // console.log();
            }
        }, timeLine);
    }

//    function getText(selector, delay) {
//        console.log('getText: ', selector);
//        return $(selector)[0].innerText;
//    }


    function getLiText (selector, delay) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            if ($(selector)[0]) {
                //console.log('getLiText2: ', selector);
                if ($(selector)[0].offsetWidth == 0) {
                    writeLog("[getLiText]fail");
                    //console.log("[getLiText]fail");
                } else {
                    var res = "";
                    for (var index = 0; index < $(selector + " > li").length; index++) {
                        if (index < $(selector + " > li").length - 1) {
                            res += $(selector + " > li")[index].innerText + ";";
                        } else {
                            res += $(selector + " > li")[index].innerText;
                        }
                    }
                    writeLog("[getLiText]success" + res);
                    //console.log("[getLiText]" + res);
                }
            } else {
                writeLog('[getLiText][ELE] "' + selector + '" not find')
                //console.log("[getLiText]fail!!!!");
            }
        }, timeLine);
    }


    function checkByTime (condition, success, error) {
        setTimeout(function () {
            var cond = condition();
            if (cond === COND_CONTINUE) {
                checkByTime(condition, success, error);
            } else if (cond === COND_OK) {
                success();
            } else {
                error();
            }
        }, timeCheckSpace);
    }


    function optionclick (selector, delay, flag) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            if ($(selector)[0]) {
                if (flag == 1) {
                    if ($(selector)[0].innerText == "")
                        $(selector)[0].click();
                } else {
                    if ($(selector)[0].innerText != "")
                        $(selector)[0].click();
                }
            } else {
                writeLog('[optionclick][ELE] "' + selector + '" not find')
            }
        }, timeLine);
    }


    function optioncheck (selector, delay, logOk, logErr) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            if ($(selector)[0]) {
                if ($(selector)[0].innerText != "") {
                    //console.log(logOk);
                    writeLog(logOk);
                } else {
                    writeLog(logErr);
                    //console.log(logErr);
                }
            } else {
                writeLog('[optioncheck][ELE] "' + selector + '" not find')
            }
        }, timeLine);
    }

    function checkText (selector, delay, expectText, logOk, logErr) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            if ($(selector)[0]) {
                if ($(selector)[0].innerText.search(expectText) != -1) {
                    //console.log(logOk);
                    writeLog(logOk);
                } else {
                    writeLog(logErr);
                    //console.log(logErr);
                }
            } else {
                writeLog('[checkText][ELE] "' + selector + '" not find')
            }

        }, timeLine);
    }

    function errorcheck (selector, delay, logOk, logErr) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            if ($(selector)[0]) {
                if ($(selector)[0].innerText == "") {
                    //console.log(logOk);
                    writeLog(logOk);
                } else {
                    writeLog(logErr);
                    //console.log(logErr);
                }
            } else {
                writeLog(logOk)
            }
        }, timeLine);
    }

    function isDom (selector, logOk, logErr, delay, maxTime) {
        delay = delay || 1000;
    	maxTime = maxTime || 25;
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            checkByTime(
                function () {
                    // condition
                    if ($(selector)[0] && $(selector)[0].offsetWidth > 0) {
                        return COND_OK;
                    } else if (maxTime-- === 0) {
                        return COND_ERROR;
                    } else {
                        return COND_CONTINUE;
                    }

                },
                function () {
                    writeLog(logOk);
                    //console.error(logOk+new Date());
                },
                function () {
                    writeLog(logErr);
                    //console.log(logErr);
                }
            );
        }, timeLine);

    }

    function isDomDo (selector, okDo, errDo, delay, maxTime) {
        delay = delay || 1000;
    	maxTime = maxTime || 60;
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            checkByTime(
                function () {
                    // condition
                    if ($(selector)[0] && $(selector)[0].offsetWidth > 0) {
                        return COND_OK;
                    } else if (maxTime-- === 0) {
                        return COND_ERROR;
                    } else {
                        return COND_CONTINUE;
                    }
                },
                function () {
                    okDo();
                },
                function () {
                    errDo();
                }
            );
        }, timeLine);
    }

    function isNotDomDo (selector, okDo, errDo, delay, maxTime) {
        delay = delay || 1000;
    	maxTime = maxTime || 60;
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            checkByTime(
                function () {
                    // condition
                    if (!$(selector)[0] || $(selector)[0].offsetWidth == 0) {
                        return COND_OK;
                    } else if (maxTime-- === 0) {
                        return COND_ERROR;
                    } else {
                        return COND_CONTINUE;
                    }
                },
                function () {
                    okDo();
                },
                function () {
                    errDo();
                }
            );
        }, timeLine);

    }


    function isNotDom (selector, logOk, logErr, delay, maxTime) {
        delay = delay || 1000;
    	maxTime = maxTime || 60;
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            checkByTime(
                function () {
                    // condition
                    if (!$(selector)[0] || $(selector)[0].offsetWidth == 0) {
                        return COND_OK;
                    } else if (maxTime-- === 0) {
                        return COND_ERROR;
                    } else {
                        return COND_CONTINUE;
                    }
                },
                // ok
                function () {
                    writeLog(logOk);
                },
                // err
                function () {
                    writeLog(logErr);
                }
            );
        }, timeLine);
    }


    // 记录日志
    function writeLogdelay (log, delay) {
        timeLine += (typeof delay !== 'undefined' ? delay : timeSpace);
        setTimeout(function () {
            window.ecDbginfo('1', 'AUTO', log)
        }, timeLine);
    }

    function writeLog (log) {
        window.ecDbginfo('1', 'AUTO', log)
    }


    // 设置input输入值
    function inputVal (selector, value, delay) {
        timeLine += (delay ? delay : timeSpace);
        setTimeout(function () {
            //console.log('inputVal: ', selector, value);
            if ($(selector)[0]) {
                var ele, ev;
                ele = $(selector)[0];
                ele.value = value;
                if (ele.fireEvent) {
                    ele.fireEvent('onchange');
                } else {
                    ev = document.createEvent('HTMLEvents');
                    ev.initEvent('change', false, true);
                    ele.dispatchEvent(ev);
                }
            } else {
                writeLog('[inputVal][ELE] "' + selector + '" not find')
            }
        }, timeLine);
    }


    function test (selector, value, delay) {
        timeLine += (delay ? delay : timeSpace);
        setTimeout(function () {
            // todosometing
        }, timeLine);
    }


    setInterval(loadConfig, timeCheckConfig);



    o.autoTest.isDom = isDom;
    o.autoTest.isDomDo = isDomDo;
    o.autoTest.isNotDom = isNotDom;
    o.autoTest.isNotDomDo = isNotDomDo;
    o.autoTest.getText = getText;
    o.autoTest.inputVal = inputVal;
    o.autoTest.click = click;
    o.autoTest.writeLog = writeLog;
    o.autoTest.optionclick = optionclick
    o.autoTest.optioncheck = optioncheck
    o.autoTest.errorcheck = errorcheck
    o.autoTest.checkText = checkText
    o.autoTest.getLiText = getLiText
    o.autoTest.textclick = textclick

})(window);

// 否则eval无法调用
window.autoJS = autoTest;






