/**
 * 修改密码相关接口
 */


!(function (o) {
    'use strict';
    function setAccountPswV1(options, next) {
        var api = new SFCommon.BaseAPI(options, events, excuting);
        function excuting(options, next) {

            SFRequest.createRequest({
                type: 'Server',
                path: 'por/changepwd.csp', //v0版本的API，它是 user/changepassword的别名 。
                //所以使用 path: "user/changepassword" 也是可以的。
                contentType: options.contentType,
                data: options.body, 
                method: 'get',
                crossDomain: '0',
                success: function (data) {   //成功时直接返回服务端的数据，不是结构体
                    options.success(data);
                    next();
                },
                error: function (data) { //错误时，返回 { code: xxx, data: {}}
                    //dosomthing
                    options.error(data);
                    next();
                }
            });
        }


        api.invoke();
    };

    o.setAccountPsw = setAccountPswV1;
})(SFAPI);